]> git.kernelconcepts.de Git - karo-tx-uboot.git/blobdiff - MAKEALL
Merge branch 'next' of git://git.denx.de/u-boot-nios
[karo-tx-uboot.git] / MAKEALL
diff --git a/MAKEALL b/MAKEALL
index e408ec61e4ff12a248b513a25a4ea7dff15a3ee7..e37000f64eaebea147cf23135f393077f432cf22 100755 (executable)
--- a/MAKEALL
+++ b/MAKEALL
@@ -1,5 +1,140 @@
 #!/bin/bash
 
+# Tool mainly for U-Boot Quality Assurance: build one or more board
+# configurations with minimal verbosity, showing only warnings and
+# errors.
+#
+# There are several ways to select which boards to build.
+#
+# Traditionally, architecture names (like "powerpc"), CPU family names
+# (like "mpc83xx") or board names can be specified on the command
+# line; without any arguments, MAKEALL defaults to building all Power
+# Architecture systems (i. e. same as for "MAKEALL powerpc").
+#
+# With the introduction of the board.cfg file, it has become possible
+# to provide additional selections.  We use standard command line
+# options for this:
+#
+# -a or --arch :       Select architecture
+# -c or --cpu  :       Select CPU family
+# -s or --soc  :       Select SoC type
+# -v or --vendor:      Select board vendor
+#
+# Selections by these options are logically ANDed; if the same option
+# is used repeatedly, such selections are ORed.  So "-v FOO -v BAR"
+# will select all configurations where the vendor is either FOO or
+# BAR.  Any additional arguments specified on the command line are
+# always build additionally.
+#
+# Examples:
+#
+# - build all Power Architecture boards:
+#
+#      MAKEALL -a powerpc
+#   or
+#      MAKEALL --arch powerpc
+#   or
+#      MAKEALL powerpc
+#
+# - build all PowerPC boards manufactured by vendor "esd":
+#
+#      MAKEALL -a powerpc -v esd
+#
+# - build all PowerPC boards manufactured either by "keymile" or
+#   "siemens":
+#
+#      MAKEALL -a powerpc -v keymile -v siemens
+#
+# - build all Freescale boards with MPC83xx CPUs, plus all 4xx boards:
+#
+#      MAKEALL -c mpc83xx -v freescale 4xx
+#
+#########################################################################
+
+SHORT_OPTS="a:c:v:s:"
+LONG_OPTS="arch:,cpu:,vendor:,soc:"
+
+# Option processing based on util-linux-2.13/getopt-parse.bash
+
+# Note that we use `"$@"' to let each command-line parameter expand to a
+# separate word. The quotes around `$@' are essential!
+# We need TEMP as the `eval set --' would nuke the return value of
+# getopt.
+TEMP=`getopt -o ${SHORT_OPTS} --long ${LONG_OPTS} \
+     -n 'MAKEALL' -- "$@"`
+
+if [ $? != 0 ] ; then echo "Terminating..." >&2 ; exit 1 ; fi
+
+# Note the quotes around `$TEMP': they are essential!
+eval set -- "$TEMP"
+
+SELECTED=''
+
+while true ; do
+       case "$1" in
+       -a|--arch)
+               # echo "Option ARCH: argument \`$2'"
+               if [ "$opt_a" ] ; then
+                       opt_a="${opt_a%)} || \$2 == \"$2\")"
+               else
+                       opt_a="(\$2 == \"$2\")"
+               fi
+               SELECTED='y'
+               shift 2 ;;
+       -c|--cpu)
+               # echo "Option CPU: argument \`$2'"
+               if [ "$opt_c" ] ; then
+                       opt_c="${opt_c%)} || \$3 == \"$2\")"
+               else
+                       opt_c="(\$3 == \"$2\")"
+               fi
+               SELECTED='y'
+               shift 2 ;;
+       -s|--soc)
+               # echo "Option SoC: argument \`$2'"
+               if [ "$opt_s" ] ; then
+                       opt_s="${opt_s%)} || \$6 == \"$2\")"
+               else
+                       opt_s="(\$6 == \"$2\")"
+               fi
+               SELECTED='y'
+               shift 2 ;;
+       -v|--vendor)
+               # echo "Option VENDOR: argument \`$2'"
+               if [ "$opt_v" ] ; then
+                       opt_v="${opt_v%)} || \$5 == \"$2\")"
+               else
+                       opt_v="(\$5 == \"$2\")"
+               fi
+               SELECTED='y'
+               shift 2 ;;
+       --)
+               shift ; break ;;
+       *)
+               echo "Internal error!" >&2 ; exit 1 ;;
+       esac
+done
+# echo "Remaining arguments:"
+# for arg do echo '--> '"\`$arg'" ; done
+
+FILTER="\$1 !~ /^#/"
+[ "$opt_a" ] && FILTER="${FILTER} && $opt_a"
+[ "$opt_c" ] && FILTER="${FILTER} && $opt_c"
+[ "$opt_s" ] && FILTER="${FILTER} && $opt_s"
+[ "$opt_v" ] && FILTER="${FILTER} && $opt_v"
+
+if [ "$SELECTED" ] ; then
+       SELECTED=$(awk '('"$FILTER"') { print $1 }' boards.cfg)
+
+       # Make sure some boards from boards.cfg are actually found
+       if [ -z "$SELECTED" ] ; then
+               echo "Error: No boards selected, invalid arguments"
+               exit 1
+       fi
+fi
+
+#########################################################################
+
 # Print statistics when we exit
 trap exit 1 2 3 15
 trap print_stats 0
@@ -52,6 +187,7 @@ boards_by_field()
 }
 boards_by_arch() { boards_by_field 2 "$@" ; }
 boards_by_cpu()  { boards_by_field 3 "$@" ; }
+boards_by_soc()  { boards_by_field 6 "$@" ; }
 
 #########################################################################
 ## MPC5xx Systems
@@ -191,6 +327,7 @@ LIST_ARM9="                 \
        ap926ejs                \
        ap946es                 \
        ap966                   \
+       aspenite                \
        cp920t                  \
        cp922_XA10              \
        cp926ejs                \
@@ -224,6 +361,8 @@ LIST_ARM9="                 \
        omap5912osk             \
        omap730p2               \
        openrd_base             \
+       openrd_client           \
+       openrd_ultimate         \
        rd6281a                 \
        sbc2410x                \
        scb9328                 \
@@ -235,7 +374,6 @@ LIST_ARM9="                 \
        spear320                \
        spear600                \
        suen3                   \
-       trab                    \
        VCMA9                   \
        versatile               \
        versatileab             \
@@ -281,9 +419,11 @@ LIST_ARM11="                       \
 ## ARMV7 Systems
 #########################################################################
 LIST_ARMV7="           \
+       am3517_crane            \
        am3517_evm              \
        ca9x4_ct_vxp            \
        devkit8000              \
+       dig297                  \
        igep0020                \
        igep0030                \
        mx51evk                 \
@@ -304,11 +444,8 @@ LIST_ARMV7="               \
 ## AT91 Systems
 #########################################################################
 
-LIST_at91="                    \
-       afeb9260                \
-       at91cap9adk             \
-       at91rm9200dk            \
-       at91rm9200ek            \
+LIST_at91="$(boards_by_soc at91)\
+       $(boards_by_soc at91rm9200)\
        at91sam9260ek           \
        at91sam9261ek           \
        at91sam9263ek           \
@@ -316,19 +453,6 @@ LIST_at91="                        \
        at91sam9g20ek           \
        at91sam9m10g45ek        \
        at91sam9rlek            \
-       cmc_pu2                 \
-       CPUAT91                 \
-       CPU9260                 \
-       CPU9G20                 \
-       csb637                  \
-       eb_cpux9k2              \
-       kb9202                  \
-       meesc                   \
-       mp2usb                  \
-       m501sk                  \
-       otc570                  \
-       pm9261                  \
-       pm9263                  \
        pm9g45                  \
        SBC35_A9G20             \
        TNY_A9260               \
@@ -339,12 +463,7 @@ LIST_at91="                        \
 ## Xscale Systems
 #########################################################################
 
-LIST_pxa="$(boards_by_cpu pxa)
-       polaris         \
-       trizepsiv       \
-       vpac270_nor     \
-       vpac270_onenand \
-"
+LIST_pxa="$(boards_by_cpu pxa)"
 
 LIST_ixp="$(boards_by_cpu ixp)
        pdnb3           \
@@ -388,9 +507,7 @@ LIST_mips4kc="              \
        vct_premium_onenand_small       \
 "
 
-LIST_mips5kc="         \
-       purple          \
-"
+LIST_mips5kc=""
 
 LIST_au1xx0="          \
        dbau1000        \
@@ -427,20 +544,16 @@ LIST_mips_el="                    \
 "
 
 #########################################################################
-## i386 Systems
+## x86 Systems
 #########################################################################
 
-LIST_x86="$(boards_by_arch i386)
-       sc520_eNET      \
-"
+LIST_x86="$(boards_by_arch x86)"
 
 #########################################################################
 ## Nios-II Systems
 #########################################################################
 
-LIST_nios2="$(boards_by_arch nios2)
-       nios2-generic   \
-"
+LIST_nios2="$(boards_by_arch nios2)"
 
 #########################################################################
 ## MicroBlaze Systems
@@ -477,39 +590,17 @@ LIST_avr32="$(boards_by_arch avr32)"
 ## Blackfin Systems
 #########################################################################
 
-LIST_blackfin="$(boards_by_arch blackfin)
-       bf527-ezkit-v2
-"
+LIST_blackfin="$(boards_by_arch blackfin)"
 
 #########################################################################
 ## SH Systems
 #########################################################################
 
-LIST_sh2="             \
-       rsk7203         \
-"
-LIST_sh3="             \
-       mpr2            \
-       ms7720se        \
-"
-
-LIST_sh4="             \
-       ms7750se        \
-       ms7722se        \
-       MigoR           \
-       r7780mp         \
-       r2dplus         \
-       sh7763rdp       \
-       sh7785lcr       \
-       ap325rxa        \
-       espt            \
-"
+LIST_sh2="$(boards_by_cpu sh2)"
+LIST_sh3="$(boards_by_cpu sh3)"
+LIST_sh4="$(boards_by_cpu sh4)"
 
-LIST_sh="              \
-       ${LIST_sh2}     \
-       ${LIST_sh3}     \
-       ${LIST_sh4}     \
-"
+LIST_sh="$(boards_by_arch sh)"
 
 #########################################################################
 ## SPARC Systems
@@ -578,7 +669,8 @@ print_stats() {
 
 #-----------------------------------------------------------------------
 
-#----- for now, just run PowerPC by default -----
+# Build target groups selected by options, plus any command line args
+set -- ${SELECTED} "$@"
+# run PowerPC by default
 [ $# = 0 ] && set -- powerpc
-
 build_targets "$@"